'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var spreadClassNames = function spreadClassNames(userClassName, baseCssClasses) {
    return (baseCssClasses || '') + ' ' + (userClassName || '');
};

var ModalHeader = function ModalHeader(props) {
    var _props$className = props.className;
    var className = _props$className === undefined ? '' : _props$className;
    var children = props.children;

    var rest = _objectWithoutProperties(props, ['className', 'children']);

    return _react2['default'].createElement(
        'div',
        _extends({ className: "modal-header " + className }, rest),
        props.children
    );
};

var ModalFooter = function ModalFooter(props) {
    var _props$className2 = props.className;
    var className = _props$className2 === undefined ? '' : _props$className2;
    var children = props.children;

    var rest = _objectWithoutProperties(props, ['className', 'children']);

    return _react2['default'].createElement(
        'div',
        _extends({ className: "modal-footer " + className }, rest),
        props.children
    );
};

var ModalBody = function ModalBody(props) {
    var _props$className3 = props.className;
    var className = _props$className3 === undefined ? '' : _props$className3;
    var children = props.children;

    var rest = _objectWithoutProperties(props, ['className', 'children']);

    return _react2['default'].createElement(
        'div',
        _extends({ className: "modal-body " + className }, rest),
        props.children
    );
};

var currentModals = [];
document.addEventListener('click', function (evt) {
    if (!currentModals.length) return;
    var modalToCloseMaybe = currentModals[currentModals.length - 1];

    var element = evt.target,
        modalRoot = modalToCloseMaybe.modalRef,
        modalContent = modalRoot.getElementsByClassName('modal-content')[0];

    if (modalContent.contains(element)) return;

    currentModals[currentModals.length - 1].props.onHide();
});

function removeBackdrop() {
    var backdrop = document.getElementsByClassName('simple-react-modal-backdrop')[0];
    if (!backdrop) return;

    var isAnimating = /\bfade\b/.test(backdrop.className);

    if (!isAnimating) {
        backdrop.parentNode.removeChild(backdrop);
    } else {
        backdrop.classList.remove('in');
        setTimeout(function () {
            return backdrop.parentNode.removeChild(backdrop);
        }, 200);
    }
}

var Modal = (function (_React$Component) {
    _inherits(Modal, _React$Component);

    function Modal() {
        _classCallCheck(this, Modal);

        _get(Object.getPrototypeOf(Modal.prototype), 'constructor', this).call(this);
        this.state = { exists: false, hasInCssClass: false };
    }

    _createClass(Modal, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (this.props.show) {
                this._showModal();
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps) {
            var _this = this;

            if (!prevProps.show && this.props.show) {
                this._showModal();
            } else if (prevProps.show && !this.props.show) {
                var isAnimating = /\bfade\b/.test(this.modalRef.className);

                if (isAnimating) {
                    this.setState({ hasInCssClass: false });
                    setTimeout(function () {
                        return !_this.dead && _this.setState({ exists: false });
                    }, 200);
                } else {
                    this.setState({ hasInCssClass: false, exists: false });
                }

                if (currentModals.length === 1) {
                    removeBackdrop();
                }
                if (currentModals[currentModals.length - 1] == this) {
                    currentModals.pop();
                }
            }
        }
    }, {
        key: '_showModal',
        value: function _showModal() {
            var _this2 = this;

            var div = !currentModals.length ? document.createElement('div') : null,
                isAnimating = /\bfade\b/.test(this.modalRef.className);

            if (div) {
                var _div$classList;

                (_div$classList = div.classList).add.apply(_div$classList, ['modal-backdrop', 'simple-react-modal-backdrop', isAnimating ? 'fade' : 'in']);
            }

            if (isAnimating) {
                if (div) {
                    document.body.appendChild(div);
                }
                this.setState({ exists: true });
                setTimeout(function () {
                    if (div) {
                        div.classList.add('in');
                    }
                    _this2.setState({ hasInCssClass: true });
                }, 1);
                //provide some small delay before this modal is eligible to be closed.  We don't want a double click to open / show the modal.
                setTimeout(function () {
                    return (/* highly unlikely, but just in case --> */!_this2.dead && currentModals.push(_this2)
                    );
                }, 200);
            } else {
                if (div) {
                    document.body.appendChild(div);
                }
                this.setState({ exists: true, hasInCssClass: true });
                currentModals.push(this);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            var children = this.props.children;
            if (!Array.isArray(children)) {
                children = [children];
            }
            var modalBody = children.find(function (c) {
                return c.type === ModalBody;
            }),
                modalHeader = children.find(function (c) {
                return c.type === ModalHeader;
            }),
                modalFooter = children.find(function (c) {
                return c.type === ModalFooter;
            });

            var _props = this.props;
            var className = _props.className;
            var style = _props.style;

            var rest = _objectWithoutProperties(_props, ['className', 'style']);

            return _react2['default'].createElement(
                'div',
                _extends({ ref: function (el) {
                        return _this3.modalRef = el;
                    }, className: spreadClassNames(className, 'modal ' + (this.state.hasInCssClass ? 'in' : '')), style: _extends({}, style, { display: this.state.exists ? 'block' : '' }) }, rest, { role: 'dialog' }),
                _react2['default'].createElement(
                    'div',
                    { className: 'modal-dialog' },
                    _react2['default'].createElement(
                        'div',
                        { className: 'modal-content' },
                        modalHeader || null,
                        modalBody || null,
                        modalFooter || null
                    )
                )
            );
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            var index = currentModals.indexOf(this);
            if (index >= 0) {
                currentModals.splice(index, 1);
                if (!currentModals.length) {
                    removeBackdrop();
                }
            }
            this.dead = true;
        }
    }]);

    return Modal;
})(_react2['default'].Component);

Modal.Body = ModalBody;
Modal.Header = ModalHeader;
Modal.Footer = ModalFooter;

exports['default'] = Modal;
module.exports = exports['default'];